'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelHelperVueJsxMergeProps = require('babel-helper-vue-jsx-merge-props');

var _babelHelperVueJsxMergeProps2 = _interopRequireDefault(_babelHelperVueJsxMergeProps);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'el-table-plus',
  props: {
    'current-change-async': {
      type: Function
    },
    'columns': {
      type: Array,
      default: []
    },
    'page-size': {
      type: Number,
      default: 20
    }
  },
  data: function data() {
    return {
      data: [],
      loading: false,
      currentPage: 1,
      total: 0
    };
  },

  methods: {
    reload: function reload() {
      this.handleCurrentChange(1);
    },
    handleCurrentChange: function handleCurrentChange(currentPage) {
      this.currentPage = currentPage;
      this.getData();
    },
    getData: function getData() {
      var _this = this;

      return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var _ref, data, total;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this.loading = true;

                _context.next = 3;
                return _this.currentChangeAsync(_this.currentPage, _this.pageSize);

              case 3:
                _ref = _context.sent;
                data = _ref.data;
                total = _ref.total;


                _this.data = data;
                _this.total = total;
                _this.loading = false;

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }))();
    }
  },
  render: function render(h) {
    var _this2 = this;

    return h(
      'div',
      { 'class': 'el-table-plus' },
      [h(
        'el-table',
        {
          attrs: { data: this.data },
          directives: [{
            name: 'loading',
            value: this.loading
          }],
          on: {
            'filter-change': function filterChange() {
              for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
              }

              return _this2.$emit.apply(_this2, ['filter-change'].concat(args));
            },
            'sort-change': function sortChange() {
              for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                args[_key2] = arguments[_key2];
              }

              return _this2.$emit.apply(_this2, ['sort-change'].concat(args));
            }
          }
        },
        [this.columns.map(function (column) {
          return column.renderBody ? h(
            'el-table-column',
            (0, _babelHelperVueJsxMergeProps2.default)([{ props: column }, { scopedSlots: {
                default: function _default(_ref2) {
                  var row = _ref2.row;

                  return column.renderBody(h, row);
                }
              } }]),
            []
          ) : h(
            'el-table-column',
            { props: column },
            []
          );
        })]
      ), h(
        'el-pagination',
        {
          attrs: { 'current-page': this.currentPage, 'page-size': this.pageSize,
            total: this.total,
            layout: 'total, prev, pager, next' },
          on: {
            'current-change': this.handleCurrentChange
          }
        },
        []
      )]
    );
  }
};